/* 
 Codelet from MILEPOST project: http://cTuning.org/project-milepost
 Updated by Grigori Fursin to work with Collective Mind Framework

 3 "./nsynth.codelet__5.wrapper.c" 3 4
*/

#include <stdio.h>

int __astex_write_message(const char * format, ...);
int __astex_write_output(const char * format, ...);
void __astex_exit_on_error(const char * msg, int code, const char * additional_msg);
void * __astex_fopen(const char * name, const char * mode);
void * __astex_memalloc(long bytes);
void __astex_close_file(void * file);
void __astex_read_from_file(void * dest, long bytes, void * file);
int __astex_getenv_int(const char * var);
void * __astex_start_measure();
double __astex_stop_measure(void * _before);
void  astex_codelet__5(long nper, long nmod, float amp_frica, float __astex_addr__nlast[1], unsigned long seed, float __astex_addr__noise[1], float __astex_addr__sourc[1], float __astex_addr__frics[1], long __astex_addr__nrand[1]);
int main(int argc, const char **argv)
{
  long  nper = 0l;
  long  nmod = 0l;
  float  amp_frica = 0.359500f;
  float  *__astex_addr__nlast;
  unsigned long  seed = 8322626ul;
  float  *__astex_addr__noise;
  float  *__astex_addr__sourc;
  float  *__astex_addr__frics;
  long  *__astex_addr__nrand;
  void * codelet_data_file_descriptor = (void *) 0;

#ifdef OPENME
  openme_init(NULL,NULL,NULL,0);
  openme_callback("PROGRAM_START", NULL);
#endif

  if (argc < 2)
    __astex_exit_on_error("Please specify data file in command-line.", 1, argv[0]);
  codelet_data_file_descriptor = __astex_fopen(argv[1], "rb");
  
  char * __astex_addr__nlast__region_buffer = (char *) __astex_memalloc(4);
  __astex_write_message("Reading __astex_addr__nlast value from %s\n", argv[1]);
  __astex_read_from_file(__astex_addr__nlast__region_buffer, 4, codelet_data_file_descriptor);
  __astex_addr__nlast = (float *) (__astex_addr__nlast__region_buffer + 0l);
  char * __astex_addr__noise__region_buffer = (char *) __astex_memalloc(4);
  __astex_write_message("Reading __astex_addr__noise value from %s\n", argv[1]);
  __astex_read_from_file(__astex_addr__noise__region_buffer, 4, codelet_data_file_descriptor);
  __astex_addr__noise = (float *) (__astex_addr__noise__region_buffer + 0l);
  char * __astex_addr__sourc__region_buffer = (char *) __astex_memalloc(4);
  __astex_write_message("Reading __astex_addr__sourc value from %s\n", argv[1]);
  __astex_read_from_file(__astex_addr__sourc__region_buffer, 4, codelet_data_file_descriptor);
  __astex_addr__sourc = (float *) (__astex_addr__sourc__region_buffer + 0l);
  char * __astex_addr__frics__region_buffer = (char *) __astex_memalloc(4);
  __astex_write_message("Reading __astex_addr__frics value from %s\n", argv[1]);
  __astex_read_from_file(__astex_addr__frics__region_buffer, 4, codelet_data_file_descriptor);
  __astex_addr__frics = (float *) (__astex_addr__frics__region_buffer + 0l);
  char * __astex_addr__nrand__region_buffer = (char *) __astex_memalloc(8);
  __astex_write_message("Reading __astex_addr__nrand value from %s\n", argv[1]);
  __astex_read_from_file(__astex_addr__nrand__region_buffer, 8, codelet_data_file_descriptor);
  __astex_addr__nrand = (long *) (__astex_addr__nrand__region_buffer + 0l);
  void * _astex_timeval_before = __astex_start_measure();
  int _astex_wrap_loop = __astex_getenv_int("CT_REPEAT_MAIN");
  if (! _astex_wrap_loop)
    _astex_wrap_loop = 1;

#ifdef OPENME
  openme_callback("KERNEL_START", NULL);
#endif

  while (_astex_wrap_loop > 0)
  {
    --_astex_wrap_loop;
  astex_codelet__5(nper, nmod, amp_frica, __astex_addr__nlast, seed, __astex_addr__noise, __astex_addr__sourc, __astex_addr__frics, __astex_addr__nrand);

  }

#ifdef OPENME
  openme_callback("KERNEL_END", NULL);
#endif

  __astex_write_output("Total time: %lf\n", __astex_stop_measure(_astex_timeval_before));


#ifdef OPENME
  openme_callback("PROGRAM_END", NULL);
#endif

  return 0;
}

